"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = checkField;

var _predicate = require("predicate");

var _predicate2 = _interopRequireDefault(_predicate);

var _utils = require("./utils");

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parseObjectRule = function parseObjectRule(rule, fieldVal) {
  return Object.keys(rule).every(function (p) {
    var subRule = rule[p];
    if (p === _constants.OR || p === _constants.AND) {
      if (Array.isArray(subRule)) {
        if (p === _constants.OR) {
          return subRule.some(function (rule) {
            return checkField(fieldVal, rule);
          });
        } else {
          return subRule.every(function (rule) {
            return checkField(fieldVal, rule);
          });
        }
      } else {
        return false;
      }
    } else if (p === _constants.NOT) {
      return !checkField(fieldVal, subRule);
    } else if (_predicate2.default[p]) {
      return _predicate2.default[p](fieldVal, subRule);
    } else {
      return false;
    }
  });
};

function checkField(fieldVal, rule) {
  if (Array.isArray(fieldVal)) {
    return (0, _utils.isObject)(rule) ? fieldVal.some(function (val) {
      return checkField(val, rule);
    }) || parseObjectRule(rule) : fieldVal.some(function (val) {
      return checkField(val, rule);
    }) || _predicate2.default[rule](fieldVal);
  } else if ((0, _utils.isObject)(rule)) {
    // Complicated rule - like { greater then 10 }
    return parseObjectRule(rule, fieldVal);
  } else {
    return _predicate2.default[rule](fieldVal);
  }
}